%define anolis_release 3

# Conditioned build zstd compression by default
%bcond_without zstd_default

Name:           logrotate
Version:        3.21.0
Release:        %{anolis_release}%{?dist}
Summary:        Rotates, compresses, removes and mails system log files

License:        GPLv2+
URL:            https://github.com/logrotate/logrotate
Source0:        https://github.com/logrotate/logrotate/releases/download/%{version}/logrotate-%{version}.tar.xz
Patch0:         logrotate-3.21.0-use-zstd-by-default.patch
BuildRequires:  acl automake gcc libacl-devel libselinux-devel make popt-devel systemd-rpm-macros 
Requires:       coreutils
Requires(post): systemd
Requires(preun): systemd

%description
The logrotate utility is designed to simplify the administration of
log files on a system which generates a lot of log files.  Logrotate
allows for the automatic rotation compression, removal and mailing of
log files.  Logrotate can be set to handle a log file daily, weekly,
monthly or when the log file gets to a certain size.

Install the logrotate package if you need a utility to deal with the
log files on your system.

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{version}-%{release}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%setup -qn %{name}-%{version}
%if %{with zstd_default}
%patch0 -p1
%endif

%build
%configure --with-state-file-path=%{_localstatedir}/lib/logrotate/logrotate.status
%make_build

%install
%make_install

mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d
mkdir -p $RPM_BUILD_ROOT%{_unitdir}
mkdir -p $RPM_BUILD_ROOT%{_localstatedir}/lib/logrotate

install -p -m 644 examples/logrotate.conf $RPM_BUILD_ROOT%{_sysconfdir}/
install -p -m 644 examples/{b,w}tmp $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d/
install -p -m 644 examples/logrotate.{service,timer} $RPM_BUILD_ROOT%{_unitdir}/

%generate_compatibility_deps

%check
%make_build -s check

%pre
if [ ! -d %{_localstatedir}/lib/logrotate/ -a -f %{_localstatedir}/lib/logrotate.status ]; then
  mkdir -p %{_localstatedir}/lib/logrotate
  cp -a %{_localstatedir}/lib/logrotate.status %{_localstatedir}/lib/logrotate
fi

%post
%systemd_post logrotate.{service,timer}

%triggerin -- logrotate < 3.14.0
[ -e %{_sysconfdir}/crontab -o -e %{_sysconfdir}/anacrontab -o -e %{_sysconfdir}/fcrontab ] \
  && %{_bindir}/systemctl enable --now logrotate.timer &>/dev/null || :


%preun
%systemd_preun logrotate.{service,timer}

%files
%license COPYING
%dir %{abidir}
%{_sbindir}/logrotate
%{abidir}/logrotate-option.list
%{_unitdir}/logrotate.{service,timer}
%{_mandir}/man8/logrotate.8*
%{_mandir}/man5/logrotate.conf.5*
%config(noreplace) %{_sysconfdir}/logrotate.conf
%dir %{_sysconfdir}/logrotate.d
%config(noreplace) %{_sysconfdir}/logrotate.d/{b,w}tmp
%dir %{_localstatedir}/lib/logrotate
%ghost %verify(not size md5 mtime) %attr(0644, root, root) %{_localstatedir}/lib/logrotate/logrotate.status

%files doc
%doc ChangeLog.md

%changelog
* Wed May 17 2023 Funda Wang <fundawang@yeah.net> - 3.21.0-3
- Use config file rather than hard-code prog names for zstd

* Mon May 15 2023 Funda Wang <fundawang@yeah.net> - 3.21.0-2
- Use zstd compression by default

* Wed Dec 14 2022 Heng Qi <hengqi@linux.alibaba.com> - 3.21.0-1
- update to 3.21.0

* Wed Sep 21 2022 mgb01105731 <mgb01105731@alibaba-inc.com> - 3.20.1-1
- update to 3.20.1

* Thu Mar 10 2022 forrest_ly <flin@linux.alibaba.com> - 1.19.0-1
- Init for Anolis OS 23 
